// rollup.config.js

import esbuild from 'rollup-plugin-esbuild';
import resolve from '@rollup/plugin-node-resolve';
import { dts } from 'rollup-plugin-dts';
/**
 * @type {import('rollup').RollupOptions}
 */
export default [
  {
    input: 'src/index.ts', // TypeScript 入口文件
    output: {
      file: 'dist/tojs.js', // 输出文件
      format: 'es', // 输出格式设置为 ES 模块
    },
    plugins: [
      resolve(), // 使用 @rollup/plugin-node-resolve 解析 node_modules 中的模块
      esbuild({
        sourcemap: true,
        minify: false,
      }),
    ],
  },
  {
    input: 'src/index.ts', // TypeScript 入口文件
    output: {
      file: 'dist/tojs.d.ts', // 输出文件
      format: 'es', // 输出格式设置为 ES 模块
    },
    plugins: [dts()],
  },
];
