import { IncomingMessage, ServerResponse } from 'http';
// import { parseBody, parseSearch } from './parse-body.ts';
// import { useContextKey } from '@kevisual/use-config/context';
import { CacheableMemory } from 'cacheable';

// const cache = useContextKey(
//   'cache',
//   () =>
//     new NodeCacheStore({
//       ttl: 5 * 60, // 5 minutes
//     }),
// );
const cache = new CacheableMemory({
  ttl: 5 * 60, // 5 minutes
});
console.log('cache init');
type Context = {
  req: IncomingMessage;
  res: ServerResponse;
  query?: any;
};
export const returnOriginalJs = async (
  ctx: Context,
  opts?: {
    prefixUrl: string;
  },
) => {
  const { req, res, query } = ctx;
  const prefixUrl = opts?.prefixUrl || '/';
  const method = req.method;
  const url = new URL(req.url, 'http://localhost');
  const pathname = url.pathname;
  const cacheKey = pathname.replace(prefixUrl, '');
  console.log('keys', cache.keys);
  if (method === 'GET') {
    let cachedCode = await cache.get(cacheKey);
    if (!cachedCode) {
      let code = decodeURIComponent((query?.urlCode as string) || '');
      if (code) {
        await cache.set(cacheKey, code);
        cachedCode = code;
      }
    }

    if (cachedCode) {
      res.setHeader('Cache-Control', 'public, max-age=43200'); // 12小时
      res.setHeader('Content-Type', 'application/javascript');
      res.end(cachedCode);
    } else {
      res.writeHead(404, { 'Content-Type': 'text/plain' });
      res.end('Resource not found');
    }
    return;
  }
  let code = decodeURIComponent((query?.urlCode as string) || '');
  if (!code) {
    code = query.code; // body code;
  }
  res.writeHead(200, { 'Content-Type': 'application/json' });
  if (code) {
    await cache.set(cacheKey, code);
    res.end(JSON.stringify({ code: 200, message: 'success' }));
  } else {
    res.end(JSON.stringify({ code: 500, message: 'code is required' }));
  }
};
